package dev.shadowsoffire.apotheosis.util;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.common.util.FakePlayer;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.event.ForgeEventFactory;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.level.block.JigsawBlock;
import net.minecraft.world.level.block.StructureBlock;
import net.minecraft.world.level.block.CommandBlock;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.level.Level;
import net.minecraftforge.common.ForgeHooks;
import net.minecraft.world.level.GameType;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.BlockGetter;
import net.minecraftforge.common.util.FakePlayerFactory;
import com.mojang.authlib.GameProfile;
import net.minecraftforge.common.UsernameCache;
import javax.annotation.Nullable;
import java.util.UUID;
import net.minecraft.world.item.ItemStack;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;

public class BlockUtil
{
    public static boolean breakExtraBlock(final ServerLevel world, final BlockPos pos, final ItemStack mainhand, @Nullable final UUID source) {
        final BlockState blockstate = world.m_8055_(pos);
        FakePlayer player;
        if (source != null) {
            player = FakePlayerFactory.get(world, new GameProfile(source, UsernameCache.getLastKnownUsername(source)));
            final Player realPlayer = world.m_46003_(source);
            if (realPlayer != null) {
                player.m_146884_(realPlayer.m_20182_());
            }
        }
        else {
            player = FakePlayerFactory.getMinecraft(world);
        }
        player.m_150109_().f_35974_.set(player.m_150109_().f_35977_, (Object)mainhand);
        if (blockstate.m_60800_((BlockGetter)world, pos) < 0.0f || !blockstate.canHarvestBlock((BlockGetter)world, pos, (Player)player)) {
            return false;
        }
        final GameType type = player.m_150110_().f_35937_ ? GameType.CREATIVE : GameType.SURVIVAL;
        final int exp = ForgeHooks.onBlockBreakEvent((Level)world, type, (ServerPlayer)player, pos);
        if (exp == -1) {
            return false;
        }
        final BlockEntity tileentity = world.m_7702_(pos);
        final Block block = blockstate.m_60734_();
        if ((block instanceof CommandBlock || block instanceof StructureBlock || block instanceof JigsawBlock) && !player.m_36337_()) {
            world.m_7260_(pos, blockstate, blockstate, 3);
            return false;
        }
        if (player.m_21205_().onBlockStartBreak(pos, (Player)player)) {
            return false;
        }
        if (player.m_36187_((Level)world, pos, type)) {
            return false;
        }
        if (player.m_150110_().f_35937_) {
            removeBlock(world, (ServerPlayer)player, pos, false);
            return true;
        }
        final ItemStack itemstack = player.m_21205_();
        final ItemStack itemstack2 = itemstack.m_41777_();
        final boolean canHarvest = blockstate.canHarvestBlock((BlockGetter)world, pos, (Player)player);
        itemstack.m_41686_((Level)world, blockstate, pos, (Player)player);
        if (itemstack.m_41619_() && !itemstack2.m_41619_()) {
            ForgeEventFactory.onPlayerDestroyItem((Player)player, itemstack2, InteractionHand.MAIN_HAND);
        }
        final boolean removed = removeBlock(world, (ServerPlayer)player, pos, canHarvest);
        if (removed && canHarvest) {
            block.m_6240_((Level)world, (Player)player, pos, blockstate, tileentity, itemstack2);
        }
        if (removed && exp > 0) {
            blockstate.m_60734_().m_49805_(world, pos, exp);
        }
        return true;
    }
    
    public static boolean removeBlock(final ServerLevel world, final ServerPlayer player, final BlockPos pos, final boolean canHarvest) {
        final BlockState state = world.m_8055_(pos);
        final boolean removed = state.onDestroyedByPlayer((Level)world, pos, (Player)player, canHarvest, world.m_6425_(pos));
        if (removed) {
            state.m_60734_().m_6786_((LevelAccessor)world, pos, state);
        }
        return removed;
    }
}
